Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1393602 - When Fedora 25 goes stable, Fedora 23 may offer upgrade to 24 or 25; we cannot know
Summary: When Fedora 25 goes stable, Fedora 23 may offer upgrade to 24 or 25; we canno...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: gnome-software
Version: rawhide
Hardware: All
OS: All
unspecified
high
Target Milestone: ---
Assignee: Richard Hughes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-11-10 00:10 UTC by Adam Williamson
Modified: 2016-11-30 03:52 UTC (History)
9 users (show)

Fixed In Version: gnome-software-3.20.5-3.fc23 gnome-software-3.20.5-3.fc24
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-11-29 23:53:22 UTC
Type: Bug
Embargoed:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
GNOME Bugzilla 774171 0 None None None 2016-11-10 00:10:53 UTC

Description Adam Williamson 2016-11-10 00:10:07 UTC
OK, that sounds pretty weird, but all the gory details are in https://bugzilla.gnome.org/show_bug.cgi?id=774171 .

On the day Fedora 25 goes stable, gnome-software in Fedora 23 may start offering the user Fedora 25 as an upgrade instead of Fedora 24. Or it may keep offering Fedora 24. We cannot actually know which it is going to do.

Software gets its list of possible releases to upgrade to from https://admin.fedoraproject.org/pkgdb/api/collections/ . The logic in Fedora 23's Software considers any higher-numbered release that is not "Under Development" to be a valid upgrade target.

If there is *more than one such release* in the list - as there will be when Fedora 25 ticks over from "Under Development" to "Active" - Fedora 23's Software will offer whichever release comes last.

The order of the 'collections' list in that JSON is basically random. The releases are grouped by status, but within each status, the order is not predictable. puiterwijk claims it's not controllable, but that may not be entirely true, we're looking into it now. But assuming we don't know and can't control whether Fedora 25 will appear after or before Fedora 24 in the list when its status is changed, we do not know what Software is going to do until the change actually happens.

This would be fairly trivial to change, but we'd have to decide on what behaviour we actually *want* from Software.

AFAIK, we don't actually offer an official recommendation on how one should accomplish an upgrade from Fedora N-2 to Fedora N. The 'upgrading with package manager' pages, in a couple of places, recommend upgrading through intermediate releases when doing a multi-release upgrade, but the instructions for DNF and GNOME Software upgrades do not state a preference. Neither did the fedup instructions, as best as I can recall.

I don't think this is really a release blocker of any kind, but I figure people might want to be forewarned (and thus forearmed) so that, at minimum, we can come up with plausible justifications for either outcome and thus claim that we knew what was going on all along. ;)

Comment 1 Fedora End Of Life 2016-11-25 09:39:16 UTC
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 2 Kalev Lember 2016-11-25 17:01:30 UTC
I fixed that in http://pkgs.fedoraproject.org/cgit/rpms/gnome-software.git/commit/?h=f23 so that F23 users get F25 upgrade when it's available, F24 users get F26 etc.

Comment 3 Fedora Update System 2016-11-25 17:02:16 UTC
gnome-software-3.20.5-3.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-914e5c1df9

Comment 4 Fedora Update System 2016-11-27 09:58:15 UTC
gnome-software-3.20.5-3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-a5c4b0bbcc

Comment 5 Fedora Update System 2016-11-29 23:53:22 UTC
gnome-software-3.20.5-3.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 6 Fedora Update System 2016-11-30 03:52:52 UTC
gnome-software-3.20.5-3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.